unit Explorateur;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ImgList, ExtCtrls, StdCtrls, Shellapi,
  ToolWin, Menus, Registry ;

procedure InitExplo ;
procedure AjoutArbo(Noeud : TTreeNode) ;
procedure SSRep(Cible : TTreeNode) ;
procedure ListeFichers(Node: TTreeNode);
function GetFileTypeString(Extension : String): String ;

function  Chemin(Cible : TTreeNode): String ;

implementation

uses Unit1 ;

// **************************************************
// *             Initialise l'explorateur           *
// **************************************************
procedure InitExplo ;
var
 Lecteurs, Nom, Fichier :  array[0..254] of char;
 i, j : Integer ;
 Buffer, Buf1 : String ;
 Position : TTreeNode ;
 Truc2,Truc3 : Cardinal ;
 N : Word ;
 H : HIcon ;
 Icone : TIcon ;
begin

   GetTempPath(sizeof(Nom), Nom);
    i := 0 ;
    Buffer := '' ;
   while Nom[i+1] <> #0 do begin
     Buffer := Buffer + Nom[i] ;
     inc(i) ;
   end ;
    strpcopy(fichier, Buffer);
    N := 0 ;
    H := ExtractAssociatedIcon(Application.Handle, Fichier, N) ;
   Icone := TIcon.Create ;
   Icone.Handle := H ;
         Form1.ImageList1.AddIcon(Icone) ;
         Form1.ImageList2.AddIcon(Icone) ;
   Icone.Free ;

   Fichier := '' ;
   Buffer := '' ;
   Nom := '' ;
  with Form1.TreeView1.Items do begin
   Clear ;
   AddFirst(GetFirstNode, 'Poste de travail') ;
   Item[0].ImageIndex := 0 ;
  end ;

   GetLogicalDriveStrings(254, Lecteurs) ;
   i := 0 ;
  while Lecteurs[i] <> #0 do begin
   while Lecteurs[i] <> #0 do begin
    If Lecteurs[i] <> '\' then Buffer := Buffer + Lecteurs[i] ;
    inc(i) ;
   end ;

    Buf1 := Buffer+'\' ;
    Nom  := '' ;
    GetVolumeInformation(@Buf1[1] ,Nom , 254, nil, Truc2, Truc3, nil, 254) ;
    n := GetDriveType(@Buf1[1]) ;

    If (Nom = '') and (n = DRIVE_CDROM)     then Nom := 'Lecteur CD' ;
    If (Nom = '') and (n = DRIVE_REMOVABLE) then Nom := 'Disque amovible' ;
    If (Nom = '') and (n = DRIVE_REMOTE)    then Nom := 'Lecteur rseau' ;

    strpcopy(fichier, Buf1);
    N := 0 ;
    H := ExtractAssociatedIcon(Application.Handle, Fichier, N) ;

   Icone := TIcon.Create ;
   Icone.Handle := H ;

    J := Form1.ImageList1.AddIcon(Icone) ;
         Form1.ImageList2.AddIcon(Icone) ;
   Icone.Free ;

    Position := Form1.TreeView1.Items.AddChild(Form1.TreeView1.Items.GetFirstNode, Nom + ' (' + Buffer + ')' ) ;
    Position.ImageIndex := J ;
    Position.SelectedIndex := J ;

    with Form1.ListView1.Items.Add do begin
      Caption := Nom + ' (' + Buffer + ')' ;
      ImageIndex := J ;
    end ;

    Buffer := '' ;
    inc(i) ;
  end ;


    If DiskFree(i) <> -1 then begin
    end ;

    SSrep(Form1.TreeView1.Items.Item[0]) ;
    Form1.TreeView1.Selected := Form1.TreeView1.Items.GetFirstNode ;
    Form1.TreeView1.Selected.Expanded := True ;

end;

// **************************************************
// *       Recherche des sous-rpertoires           *
// **************************************************
procedure AjoutArbo(Noeud : TTreeNode) ;
var
  Chem : String ;
  Pos : TTreeNode ;
  fichier : TSearchRec ;
begin

 If (Noeud.Parent <> nil) and (not Noeud.HasChildren) then begin
  chem := Chemin(Noeud) ;
  Chem := Chem + '\*.*' ;

         if FindFirst(Chem, faDirectory	, Fichier) = 0 then begin ;
             if ((Fichier.Attr and faDirectory) = faDirectory) and (Fichier.Name <> '..') and (Fichier.Name <> '.') then begin
                  Pos := form1.TreeView1.Items.AddChild(Noeud, Fichier.Name) ;
                  Pos.ImageIndex := 1 ;
                  Pos.SelectedIndex := 1 ;
             end ;

            while FindNext(Fichier) = 0 do begin ;
             if ((Fichier.Attr and faDirectory) = faDirectory) and (Fichier.Name <> '..') and (Fichier.Name <> '.') then begin
                  Pos := form1.TreeView1.Items.AddChild(Noeud, Fichier.Name) ;
                  Pos.ImageIndex := 1 ;
                  Pos.SelectedIndex := 1 ;
             end ;
            end ;
           FindClose(Fichier) ;
           FindNext(Fichier) ;
         end ;
 end ;
end ;

// **************************************************
// *       Convertie le chemin en un chaine         *
// **************************************************
function Chemin(Cible : TTreeNode): String ;
begin
   Result := '' ;
 If Cible.Parent <> nil then
  while (Cible.Parent.Text <> 'Poste de travail') do begin
   Result := '\' + Cible.Text + Result ;
   Cible := Cible.Parent ;
  end ;

 Result := Copy(Cible.Text, length(Cible.Text)-2, 2) + Result ;
end ;

// **************************************************
// *    Ajoute le contenu des sous-repertoires      *
// **************************************************
procedure SSRep(Cible : TTreeNode) ;
begin
    Cible := Cible.getFirstChild ;
   while Cible <> nil do begin
    AjoutArbo(Cible) ;
    Cible := Cible.GetNextChild(Cible) ;
   end ;
end ;

// **************************************************
// *         Liste les fichier d'un rpertoire      *
// **************************************************
procedure ListeFichers(Node: TTreeNode);
var
  Fich :  array[0..254] of char;
  Chem : String ;
  Pos : TTreeNode ;
  fichier : TSearchRec ;
  j : Integer ;
  p : TWin32FindData;
  Heures : SYSTEMTIME ;
  Liste : TStrings ;

    // Donne l'index de l'icone  mettre au fichier
    function GetIcone(Fichier : String): Integer ;
    var
      H : HIcon ;
      PosListe : Integer ;
      N : Word ;
      Icone : TIcon ;
      Extension : String ;
    begin
      Extension := UpperCase(ExtractFileExt(Fichier)) ;
        PosListe := Liste.IndexOf(Extension) ;
      If (PosListe = -1) or (Extension = '.EXE') or (Extension = '.BMP') or
         (Extension = '.ICO') or (Extension = '.JPG') or (Extension = '.LNK') then begin
        Liste.Add(Extension) ;
          N := 0 ;
          H := ExtractAssociatedIcon(0, Fich, N) ;
              Icone := TIcon.Create ;
              Icone.Handle := H ;
                   J := form1.ImageList3.AddIcon(Icone) ;
                        form1.ImageList4.AddIcon(Icone) ;
              Icone.Free ;
         Result := J ;
      end else Result := form1.ImageList1.Count+PosListe ;
    end ;

begin
  form1.ListView1.Visible := False ;
  form1.ListView1.Items.Clear ;
  form1.ListView1.Visible := True ;

  Pos := Node.getFirstChild ;
    // Rajoute les dossiers en premiers
    while Pos <> nil do begin
     with form1.ListView1.Items.Add do begin
      Caption := Pos.Text ;
      ImageIndex := Pos.ImageIndex ;
      SubItems.Add('') ;
      SubItems.Add(GetFileTypeString('Directory')) ;

     strpcopy(fich, Chemin(Node)+'\'+Caption);

     If (FindFirstFile(fich, p) <> INVALID_HANDLE_VALUE) then begin
         FileTimeToSystemTime(p.ftLastWriteTime, Heures) ;
         with Heures do SubItems.Add(Format('%.2d/%.2d/%.4d %.2d:%.2d', [wDay, wMonth, wYear, (wHour+2) mod 24, wMinute])) ; // +2 Heures pour l'heure franaise
     end ;
     end ;
     Pos := Pos.GetNextChild(Pos) ;
    end ;

    // Ensuite les fichiers...
     Liste := TStringList.Create ;

     // Efface et ajoute l'icone des dossier  la liste
    form1.ImageList3.Clear ;
    form1.ImageList4.Clear ;
    form1.ImageList3.Assign(form1.ImageList2) ;
    form1.ImageList4.Assign(form1.ImageList1) ;

 If (Node.Parent <> nil) then begin
  chem := Chemin(Node) ;
  Chem := Chem + '\*.*' ;

         if FindFirst(Chem, faAnyFile, Fichier) = 0 then begin ;

            while FindNext(Fichier) = 0 do begin ;
             if ((Fichier.Attr and faDirectory) <> faDirectory) then
                     with form1.ListView1.Items.Add do begin
                      Caption := Fichier.Name ;

                     strpcopy(fich, copy(chem, 0, length(chem)-3)+Fichier.Name);
                     // Rcuperation de l'icone
                     ImageIndex := GetIcone(String(Fich)) ;

                  FindFirstFile(fich, p);
                  FileTimeToSystemTime(p.ftLastWriteTime, Heures) ;
                  SubItems.Text := FormatFloat('#,###" Ko"', (Trunc(p.nFileSizeLow/1024)+1));
                  SubItems.Add(GetFileTypeString(ExtractFileExt(Fichier.Name))) ;
                  with Heures do SubItems.Add(Format('%.2d/%.2d/%.4d %.2d:%.2d', [wDay, wMonth, wYear, (wHour+2) mod 24, wMinute])) ;

                     end ;
            end ;
           FindClose(Fichier) ;
           FindNext(Fichier) ;
         end ;

 end ;

   Liste.Free ;
end;

// **************************************************
// *    Rcupre le texte associ  une extension   *
// **************************************************
function GetFileTypeString(Extension : String): String ;
var
 Registry : TRegistry ;
begin
  Result := 'Fichier '+UpperCase(copy(Extension, 2, MAX_PATH)) ;
  Registry := TRegistry.Create(KEY_READ);
  try
    Registry.RootKey := HKEY_CLASSES_ROOT;
    // False car nous ne voulons pas la crer si elle n'existe pas
    if Registry.KeyExists(Extension) then begin
        Registry.OpenKey(Extension, False);
        if UpperCase(Extension) <> 'DIRECTORY' then
            Extension := Registry.ReadString('') ;
        Registry.CloseKey ;
       If Extension <> '' then begin
          If Registry.KeyExists(Extension) then
           Registry.OpenKey(Extension, False) ;
           Result := Registry.ReadString('') ;
       end ;
    end ;
  finally
    Registry.Free;
  end;
end ;

end.
